#!/usr/bin/python
#
# saku.py - shinGETsu clone.
# Copyright (C) 2005  shinGETsu Project.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: saku.py,v 1.11 2005/04/03 03:26:29 fuktommy Exp $
#

import os
import sys
import time

import shingetsu.config
import shingetsu.httpd
import shingetsu.crond

__version__ = "$Revision: 1.11 $"

import time
class Logger:

    """Save logs to /LOGDIR/%Y-%m-%d."""

    def __init__(self, logdir):
        self.logdir = logdir
        self.logfile = ""
        self.outout = None

    def write(self, msg):
        newlog = self.logdir + "/" + \
                 time.strftime("%Y-%m-%d", time.localtime())
        if self.logfile == newlog:
            pass
        elif self.logfile == "":
            self.logfile = newlog
            self.output = file(self.logfile, "a")
        else:
            self.output.close()
            self.logfile = newlog
            self.output = file(self.logfile, "a")
        self.output.write(msg)
        self.output.flush()

    def flush(self):
        pass

    def close(self):
        self.output.close()


def main():
    if "PYTHONPATH" in os.environ:
        if hasattr(sys, "winver"):
            sep = ";"
        else:
            sep = ":"
        os.environ["PYTHONPATH"] += sep + sys.path[0]
    else:
        os.environ["PYTHONPATH"] = sys.path[0]

    argv = sys.argv[1:]
    if hasattr(sys, "winver"):
        light_cgi = True
    else:
        light_cgi = False
    logdir = ""
    while argv:
        i = argv.pop(0)
        if i == "-t":
            light_cgi = True
        elif i == "+t":
            light_cgi = False
        elif (i == "-l") and argv:
            logdir = argv.pop(0)

    if light_cgi:
            shingetsu.config.flags.append("light_cgi")
    if light_cgi and logdir:
        logger = Logger(logdir)
        sys.stderr = logger
        sys.stdout = logger

    try:
        crond = shingetsu.crond.Crond()
        crond.setDaemon(True)
        crond.start()

        httpd = shingetsu.httpd.Httpd()
        httpd.start()

    except KeyboardInterrupt:
        sys.exit()

if __name__ == "__main__":
    main()
