#!/bin/bash -e
#
# Controller Interface of SAKU.
#
# Copyright (C) 2005  shinGETsu Project.
# $Id: saku.sh,v 1.7 2005/03/29 00:31:34 fuktommy Exp $
#

PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin
LANG=C

DIR=/home/saku
INTERPRETER=/usr/bin/python
SCRIPT=./saku.py
THREADING=yes
LOGTOOL=/usr/local/sbin/datelog
LOGDIR=/var/log/saku

NICE="+10"
NPROC=20

start () {
    umask 0000
    ulimit -u $NPROC
    cd $DIR
    if [ "$THREADING" = "yes" ]; then
        nice -n $NICE $SCRIPT -t -l $LOGDIR < /dev/null > /dev/null 2>&1 &
    else
        nice -n $NICE $SCRIPT < /dev/null 2>&1 | $LOGTOOL $LOGDIR &
    fi
}

stop () {
    killall -TERM $INTERPRETER > /dev/null 2>&1
    killall -KILL $INTERPRETER > /dev/null 2>&1 || true
}


if ! [ -x "$DIR/$SCRIPT" ]; then
    exit 0
fi

case "$1" in
    start)
        start
    ;;
    stop)
        stop
    ;;
    restart)
        stop
        start
    ;;
    *)
        echo "Usage: $0 {start|stop|restart}"
        exit 1
    ;;
esac

exit 0
